<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Airline ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Airline extends AbstractStructArrayBase
{
    /**
     * The Airline
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Airline[]
     */
    public $Airline;
    /**
     * Constructor method for ArrayOfJP_Airline
     * @uses ArrayOfJP_Airline::setAirline()
     * @param \StructType\JP_Airline[] $airline
     */
    public function __construct(array $airline = array())
    {
        $this
            ->setAirline($airline);
    }
    /**
     * Get Airline value
     * @return \StructType\JP_Airline[]|null
     */
    public function getAirline()
    {
        return $this->Airline;
    }
    /**
     * This method is responsible for validating the values passed to the setAirline method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirline method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirlineForArrayConstraintsFromSetAirline(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_AirlineAirlineItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_AirlineAirlineItem instanceof \StructType\JP_Airline) {
                $invalidValues[] = is_object($arrayOfJP_AirlineAirlineItem) ? get_class($arrayOfJP_AirlineAirlineItem) : sprintf('%s(%s)', gettype($arrayOfJP_AirlineAirlineItem), var_export($arrayOfJP_AirlineAirlineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Airline property can only contain items of type \StructType\JP_Airline, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Airline value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Airline[] $airline
     * @return \ArrayType\ArrayOfJP_Airline
     */
    public function setAirline(array $airline = array())
    {
        // validation for constraint: array
        if ('' !== ($airlineArrayErrorMessage = self::validateAirlineForArrayConstraintsFromSetAirline($airline))) {
            throw new \InvalidArgumentException($airlineArrayErrorMessage, __LINE__);
        }
        $this->Airline = $airline;
        return $this;
    }
    /**
     * Add item to Airline value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Airline $item
     * @return \ArrayType\ArrayOfJP_Airline
     */
    public function addToAirline(\StructType\JP_Airline $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Airline) {
            throw new \InvalidArgumentException(sprintf('The Airline property can only contain items of type \StructType\JP_Airline, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Airline[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Airline|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Airline|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Airline|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Airline|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Airline|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Airline
     */
    public function getAttributeName()
    {
        return 'Airline';
    }
}
